<template>
  <el-drawer title="知识关键词" v-model="drawerVisible" size="40%">
      <el-form :model="state.queryParams" ref="ruleFormRef" :inline="true" @submit.native.prevent>
        <el-form-item label="关键词" prop="Tag">
          <el-input v-model="state.queryParams.Tag" placeholder="请输入关键词" clearable @keyup.enter="queryList" />
        </el-form-item>
        <el-form-item>
          <el-button type="primary" @click="queryList" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
          <el-button @click="resetQuery(ruleFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
        </el-form-item>
      </el-form>
      <div class="mb20">
        <el-button type="primary" @click="addParameter" v-auth="'auxiliary:knowledgeLexicon:add'">
          <SvgIcon name="ele-Plus" class="mr5" />新增
        </el-button>
        <el-button type="primary" @click="businessTagRemove" v-auth="'auxiliary:knowledgeLexicon:delete'" :disabled="!multipleSelection.length">
          <SvgIcon name="ele-Delete" class="mr5" />删除
        </el-button>
      </div>
      <!-- 表格 -->
      <el-table :data="state.tableData" v-loading="state.loading" row-key="id" ref="multipleTableRef" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" :reserve-selection="true"/>
        <el-table-column prop="tag" label="关键词" show-overflow-tooltip></el-table-column>
        <el-table-column prop="synonym" label="同义词" show-overflow-tooltip></el-table-column>
        <el-table-column label="操作" width="120" fixed="right" align="center">
          <template #default="{ row }">
            <el-button link type="primary" @click="updateLexicon(row)" v-auth="'auxiliary:knowledgeLexicon:edit'" title="编辑知识库词库">
              编辑
            </el-button>
          </template>
        </el-table-column>
        <template #empty>
          <Empty />
        </template>
      </el-table>
      <!-- 分页 -->
      <pagination
          :total="state.total"
          v-model:page="state.queryParams.PageIndex"
          v-model:limit="state.queryParams.PageSize"
          @pagination="queryList"
      />
    <template #footer>
			<span class="dialog-footer">
				<el-button @click="drawerVisible = false" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onConfirm" :loading="state.loading">提 交</el-button>
			</span>
    </template>
  </el-drawer>
  <!--  新增知识库词库  -->
  <knowledge-lexicon-add ref="knowledgeLexiconAddRef" @updateList="queryList" :knowledgeWordClassify="knowledgeWordClassify"/>
  <!--  编辑知识库词库  -->
  <knowledge-lexicon-edit ref="knowledgeLexiconEditRef" @updateList="queryList" :knowledgeWordClassify="knowledgeWordClassify"/>
</template>
<script setup lang="ts">
import {defineAsyncComponent, reactive, ref} from "vue";
import {knowledgeLexiconDelete, knowledgeLexiconList, orderKnowledgeBaseData} from '/@/api/auxiliary/knowledgeLexicon';
import {auth} from "/@/utils/authFunction";
import {ElMessage, ElMessageBox, FormInstance} from "element-plus";

// 引入组件
const KnowledgeLexiconAdd = defineAsyncComponent(() => import('/@/views/auxiliary/knowledgeLexicon/components/Knowledge-lexicon-add.vue')); // 新增知识库词库
const KnowledgeLexiconEdit = defineAsyncComponent(() => import('/@/views/auxiliary/knowledgeLexicon/components/Knowledge-lexicon-edit.vue')); // 编辑知识库词库

const emit = defineEmits(['selectKeyword'])

const drawerVisible = ref<boolean>(false);

const state = reactive<any>({
  queryParams: {
    // 查询参数
    PageIndex: 1,
    PageSize: 10,
    Tag: null, // 标签
    Classify: null, // 标签类型
    Synonym: null, // 近义词
  },
  total: 0, // 总条数
  tableData: [], // 表格数据
});
const ruleFormRef = ref<any>(null); // 表单ref
const knowledgeWordClassify = ref<EmptyArrayType>();// 标签类型
const keywordIds = ref<EmptyArrayType>();// 关键词ID
// 获取基础数据
const getBaseData = async ()=>{
  try {
    const res = await orderKnowledgeBaseData();
    knowledgeWordClassify.value = res.result?.knowledgeWordClassify ?? [];
  }catch (error){
    console.log(error)
  }
}
// 获取参数列表
const queryList = () => {
  state.loading = true;
  if (!auth('auxiliary:knowledgeLexicon:query')) ElMessage.error('抱歉，您没有权限获取知识库词库列表！');
  else {
    knowledgeLexiconList(state.queryParams)
        .then((res) => {
          state.loading = false;
          state.tableData = res.result.items ?? [];
          state.total = res.result.total ?? 0;
          multipleTableRef.value!.clearSelection();
          if(keywordIds.value && keywordIds.value.length){
            for (let i of keywordIds.value) {
              for (let j of state.tableData) {
                if (i === j.id) {
                  setTimeout(() => {
                    multipleTableRef.value!.toggleRowSelection(j, true);
                    multipleSelection.value.push(j);
                  }, 0);
                }
              }
            }
          } else {
            multipleSelection.value = [];
            multipleTableRef.value!.clearSelection();
          }
        })
        .finally(() => {
          state.loading = false;
        });
  }
};
// 重置表单
const resetQuery = (formEl: FormInstance | undefined) => {
  if (!formEl) return;
  formEl.resetFields();
  queryList();
};
// 新增词库
const knowledgeLexiconAddRef = ref<RefType>();
const addParameter = () => {
  knowledgeLexiconAddRef.value.openDialog();
};
// 编辑知识库词库
const knowledgeLexiconEditRef = ref<RefType>();
const updateLexicon = (row: any) => {
  knowledgeLexiconEditRef.value.openDialog(row.id);
};
// 表格多选
const multipleTableRef = ref<RefType>();
const multipleSelection = ref<any>([]);
const handleSelectionChange = (val: any[]) => {
  multipleSelection.value = val;
};
// 删除词库
const businessTagRemove = () => {
  const ids = multipleSelection.value.map((item: any) => item.id);
  const names = multipleSelection.value.map((item: any) => item.tag);
  ElMessageBox.confirm(`您确定要删除：【${names}】，是否继续?`, '提示', {
    confirmButtonText: '确认',
    cancelButtonText: '取消',
    type: 'warning',
    draggable: true,
    cancelButtonClass: 'default-button',
    autofocus: false,
  })
      .then(() => {
        knowledgeLexiconDelete({ids}).then(() => {
          ElMessage.success('操作成功');
          queryList();
        });
      })
      .catch(() => {});
};
// 确定选择关键词
const onConfirm = ()=>{
  const ids = multipleSelection.value.map((item: any) => item.id);
  const name = multipleSelection.value.map((item: any) => item.tag).join(',');
  emit('selectKeyword',{ids,name});
  drawerVisible.value = false;
}
// 打开弹窗
const openDialog = (keywords:any[]) => {
  keywordIds.value = keywords;
  getBaseData();
  queryList();
  drawerVisible.value = true;
};
// 关闭弹窗
const closeDialog = () => {
  drawerVisible.value = false;
};
defineExpose({
  openDialog,
  closeDialog,
});
</script>